

######function for reverse cusum######
cumsum_rev=function(x){
  y = rev(cumsum(rev(x)))
  return(y)
}
###############################################



########################################33
###function for one-step Newton method

##faster than ddloglik_schoenfeld_bs_t and ddloglik_schoenfeld_bs_t_loop
ddloglik_schoenfeld_bs_t = function(n,delta,z,beta=constant_beta, B_spline=bs8, knot=knot,theta=theta){
  p = length(beta)
  L = matrix(0,nrow=p,ncol=p)
  V=rep(0, p*p*n)
  dim(V)=c(p,p,n)
  schoenfeld=matrix(0,nrow=n,ncol=p)
  partial_likelihood=0
  
  GVG=matrix(0,nrow=p*knot,ncol=p*knot)
  #GV=matrix(0,nrow=p*knot,ncol=p*knot)
  
  GR_test=rep(0,p*knot)
  GR=rep(0,p*knot)
  list=1:n
  S0<-vapply(list, function(x) sum(exp(z[x:N,]%*%theta%*%(B_spline[x,]))),FUN.VALUE=numeric(1))
  S1<-t(vapply(list, function(x) colSums(matrix(z[x:n,]*as.vector(exp(z[x:N,]%*%theta%*%(B_spline[x,]))), ncol=p)),FUN.VALUE=numeric(p)))
  schoenfeld=delta*(z - S1/S0)
  # partial_likelihood=sum(delta*((z%*%theta%*%t(B_spline))-log(S0)))
  partial_likelihood=sum(vapply(list, function(x) delta[x]*(z[x,]%*%theta%*%B_spline[x,]-log(S0[x])),FUN.VALUE=numeric(1)))
  
  S2= rep(0,p*p*n)
  dim(S2)=c(p,p,n)
  
  i2=0
  repeat{
    i2=i2+1
    S2[,i2,]=(vapply(list, function(x) colSums(matrix(z[x:n,]*as.vector(exp(z[x:N,]%*%theta%*%(B_spline[x,])))*z[x:n,i2], ncol=p)),FUN.VALUE=numeric(p)))
    if (i2==p) break
  }
  
  #V=vapply(list, function(x)(S2[,,x]/S0[x] - matrix(S1[x,],ncol=1)%*% matrix(S1[x,],ncol=p)/(S0[x] *S0[x])),outer(1:p,1:p))
  S0_2=S0[delta==1]
  S1_2=S1[delta==1,]
  S2_2=S2[,,delta==1]
  list2=1:sum(delta)
  B_spline2=B_spline[delta==1,]
  schoenfeld2=schoenfeld[delta==1,]
  
  GVG_pre=vapply(list2, function(x)kronecker((S2_2[,,x]/S0_2[x] - matrix(S1_2[x,],ncol=1)%*% matrix(S1_2[x,],ncol=p)/(S0_2[x] *S0_2[x])),B_spline2[x,]%*%t(B_spline2[x,]), FUN = "*") ,outer(1:(p*knot),1:(p*knot)))
  
  GVG=matrix(0, nrow=p*knot,ncol=p*knot)
  j=0
  repeat{
    j=j+1
    GVG[,j]=rowSums(GVG_pre[,j,])
    if (j==p*knot) break
  }
  
  GR_test=rowSums(vapply(list2, function(x) kronecker(schoenfeld2[x,],B_spline2[x,], FUN = "*"),numeric(p*knot)))
  
  list(schoenfeld=schoenfeld2, GVG=GVG, GR_test=GR_test, partial_likelihood=partial_likelihood) 
} 
############################################################




#################################################################################
##Function for unstratified initial H/K (Approximation for Hessian matrix) estimator

ddloglik_schoenfeld= function(n,delta,z,beta, B_spline=bs8, knot=knot){
  p = length(beta)
  
  scaled_schoenfeld=matrix(0,nrow=n,ncol=p)
  GVG=matrix(0,nrow=p*knot,ncol=p*knot)
  S0=rev(cumsum(rev(exp(z%*%beta))))
  S1_pre=sweep(z, MARGIN=1, exp(z%*%beta),'*')
  S1=apply(S1_pre,MARGIN=2,cumsum_rev)
  S2=rep(0,n*p*p)
  dim(S2)=c(n,p,p)
  B_square=rep(0,n*knot*knot)
  dim(B_square)=c(n,knot,knot)
  V=S2
  schoenfeld=delta*(z - S1/S0)
  partial_likelihood=delta*((z%*%beta)-log(S0))
  
  
  j=0
  repeat{
    j=j+1
    B_square[,,j]=matrix(B_spline*B_spline[,j],ncol=knot)
    if (j==knot) break
  }
  
  GR_test=NULL
  GVG=NULL
  j=0
  repeat{
    j=j+1
    
    S2[,,j]=apply(matrix(z*as.vector(exp(z%*%beta))*z[,j],ncol=p),MARGIN=2,cumsum_rev)
    V[,,j]=S2[,,j]/S0-S1*S1[,j]/(S0**2)
    GR_test=c(GR_test, colSums(sweep(B_spline, MARGIN=1, schoenfeld[,j],'*')))
    
    
    GVG_pre2=NULL
    j2=0
    repeat{
      j2=j2+1 
      
      GVG_pre3=NULL
      j3=0
      repeat{
        j3=j3+1
        GVG_pre3=rbind(GVG_pre3,matrix(colSums(sweep(B_square[,,j2], MARGIN=1, delta*V[,j3,j],'*')),ncol=1))
        if (j3==p) break
      }
      GVG_pre2=cbind(GVG_pre2,GVG_pre3)
      if (j2==knot) break
    }
    
    GVG=cbind(GVG,GVG_pre2)
    if (j==p) break
  }
  
  
  V3=V[delta==1,,]
  schoenfeld2=schoenfeld[delta==1,]
  
  #V3=t(apply(V2,1,solve))
  #list2=1:sum(delta)
  # V4=t(vapply(list2, function(x)  qr.solve(V3[x,,], schoenfeld2[x,], tol=1.0e-20)), numeric(p))
  V4=t(apply(V3,1,function(x) qr.solve(x, diag(p), tol=1.0e-20)))
  
  scaled_schoenfeld=matrix(0,nrow=sum(delta),ncol=p)
  j=0
  repeat{
    j=j+1
    V5=V4[,(p*((1:p)-1)+j)]
    scaled_schoenfeld=scaled_schoenfeld+sweep(V5,MARGIN=1, schoenfeld2[,j],'*')
    if (j==p) break
  }
  
  list(schoenfeld=schoenfeld2,GR_test=GR_test,GVG=GVG,  partial_likelihood=partial_likelihood, scaled_schoenfeld=scaled_schoenfeld) 
} 
##################################################





##########################################################
##########Function for Stratified initial H/K (approximation for Hessian matrix)

ddloglik_schoenfeld_stratify= function(n,delta,z,beta, B_spline=bs8, knot=knot, facility=facility, number_facility=F){
  p = length(beta)
  
  GVG=matrix(0,nrow=p*knot,ncol=p*knot)
  
  
  B_square=rep(0,n*knot*knot)
  dim(B_square)=c(n,knot,knot)
  
  j=0
  repeat{
    j=j+1
    B_square[,,j]=matrix(B_spline*B_spline[,j],ncol=knot)
    if (j==knot) break
  }
  
  
  S0=rep(0,p)
  S1=matrix(0, nrow=n, ncol=p)
  S2=rep(0,n*p*p)
  dim(S2)=c(n,p,p)
  V=S2
  GVG=NULL
  
  F_key=0
  while (F_key<number_facility){
    F_key=F_key+1
    z_temp=z[facility==F_key,]
    S0[facility==F_key]<-rev(cumsum(rev(exp(z_temp%*%beta))))
    S1_pre=sweep(z_temp, MARGIN=1, exp(z_temp%*%beta),'*')
    S1[facility==F_key,]=apply(S1_pre,MARGIN=2,cumsum_rev)
    
    size_temp=length(delta[facility==F_key])
    S2_temp= rep(0,size_temp*p*p)
    dim(S2_temp)=c(size_temp, p,p)
    
    j=0
    repeat{
      j=j+1
      
      S2_temp[,,j]=apply(matrix(z_temp*as.vector(exp(z_temp%*%beta))*z_temp[,j],ncol=p),MARGIN=2,cumsum_rev)      
      if (j==p) break
    }
    S2[facility==F_key,,]= S2_temp
  }
  
  
  
  schoenfeld=delta*(z - S1/S0)
  
  
  GR_test=NULL
  GVG=NULL
  j=0
  repeat{
    j=j+1
    V[,,j]=S2[,,j]/S0-S1*S1[,j]/(S0**2)
    
    GR_test=c(GR_test, colSums(sweep(B_spline, MARGIN=1, schoenfeld[,j],'*')))
    
    
    GVG_pre2=NULL
    j2=0
    repeat{
      j2=j2+1 
      
      GVG_pre3=NULL
      j3=0
      repeat{
        j3=j3+1
        GVG_pre3=rbind(GVG_pre3,matrix(colSums(sweep(B_square[,,j2], MARGIN=1, delta*V[,j3,j],'*')),ncol=1))
        if (j3==p) break
      }
      GVG_pre2=cbind(GVG_pre2,GVG_pre3)
      if (j2==knot) break
    }
    GVG=cbind(GVG,GVG_pre2)
    if (j==p) break
  }
  
  
  partial_likelihood=delta*((z%*%beta)-log(S0))
  
  
  list(GR_test=GR_test,GVG=GVG,  partial_likelihood=partial_likelihood) 
} 
##########################################################################3




###########################################
##Function for quasi-Newton

####################################################################################33
####all beta are time-varying
ddloglik_schoenfeld_bs_t_quasi_L1= function(n,delta,z, B_spline=bs8, theta=theta){
  
  #GV=matrix(0,nrow=p*knot,ncol=p*knot)
  list=1:n
  
  S0<-vapply(list, function(x) sum(exp(z[x:N,]%*%theta%*%(B_spline[x,]))),FUN.VALUE=numeric(1))
  S1<-t(vapply(list, function(x) colSums(matrix(z[x:n,]*as.vector(exp(z[x:N,]%*%theta%*%(B_spline[x,]))), ncol=p)),FUN.VALUE=numeric(p)))
  schoenfeld=delta*(z - S1/S0)
  # partial_likelihood=sum(delta*((z%*%theta%*%t(B_spline))-log(S0)))
  partial_likelihood=sum(vapply(list, function(x) delta[x]*(z[x,]%*%theta%*%B_spline[x,]-log(S0[x])),FUN.VALUE=numeric(1)))
  
  
  S0_2=S0[delta==1]
  S1_2=S1[delta==1,]
  
  list2=1:sum(delta)
  B_spline2=B_spline[delta==1,]
  schoenfeld2=schoenfeld[delta==1,]
  GR_test=rowSums(vapply(list2, function(x) kronecker(schoenfeld2[x,],B_spline2[x,], FUN = "*"),numeric(p*knot)))
  list(L1=-GR_test, partial_likelihood=partial_likelihood) 
} 
#######################################################################333






###########################################
##Function for cumulative hazard

####################################################################################33
####all beta are time-varying
Lambda= function(n,delta,z, B_spline=bs8, theta=theta){
  Lambda=rep(0,n)
  #GV=matrix(0,nrow=p*knot,ncol=p*knot)
  list=1:n
  
  S0<-vapply(list, function(x) sum(exp(z[x:N,]%*%theta%*%(B_spline[x,]))),FUN.VALUE=numeric(1))
 
  temp=delta/S0
  Lambda=cumsum(temp)
  list(Lambda=Lambda) 
} 
#######################################################################333






###################################################
#Function for stratified quasi-Newton

ddloglik_schoenfeld_bs_t_quasi_L1_stratify= function(n,delta,z, B_spline=bs8, theta=theta, facility=facility, number_facility=F){
  
  #GV=matrix(0,nrow=p*knot,ncol=p*knot)
  list=1:n
  
  S0=rep(0,n)
  S1=matrix(0,nrow=n,ncol=p)
  
  size_key=0
  F_key=0
  while (F_key<number_facility){
    F_key=F_key+1
    size_temp=length(delta[facility==F_key])
    list=1:size_temp
    z_temp=z[facility==F_key,]
    B_spline_temp=B_spline[facility==F_key,]
    S0[facility==F_key]<-vapply(list, function(x) sum(exp(z_temp[x:size_temp,]%*%theta%*%(B_spline_temp[x,]))),FUN.VALUE=numeric(1))
    S1[facility==F_key,]<-t(vapply(list, function(x) colSums(matrix(z_temp[x:size_temp,]*as.vector(exp(z_temp[x:size_temp,]%*%theta%*%(B_spline_temp[x,]))), ncol=p)),FUN.VALUE=numeric(p)))
  }
  
  
  schoenfeld=delta*(z - S1/S0)
  # partial_likelihood=sum(delta*((z%*%theta%*%t(B_spline))-log(S0)))
  partial_likelihood=sum(vapply(list, function(x) delta[x]*(z[x,]%*%theta%*%B_spline[x,]-log(S0[x])),FUN.VALUE=numeric(1)))
  
  
  S0_2=S0[delta==1]
  S1_2=S1[delta==1,]
  
  list2=1:sum(delta)
  B_spline2=B_spline[delta==1,]
  schoenfeld2=schoenfeld[delta==1,]
  GR_test=rowSums(vapply(list2, function(x) kronecker(schoenfeld2[x,],B_spline2[x,], FUN = "*"),numeric(p*knot)))
  list(L1=-GR_test, partial_likelihood=partial_likelihood) 
} 
##########################


###########################################
##Function for stratify cumulative hazard

####################################################################################33
####all beta are time-varying
Lambda_stratify= function(n,delta,z, B_spline=bs8, theta=theta, facility=facility, number_facility=F){
  Lambda=rep(0,n)
  #GV=matrix(0,nrow=p*knot,ncol=p*knot)
  list=1:n
  S0=rep(0,n)
  
  size_key=0
  F_key=0
  while (F_key<number_facility){
    F_key=F_key+1
    index=which(facility==F_key)
    size_temp=length(delta[index])
    list=1:size_temp
    z_temp=z[index,]
    B_spline_temp=B_spline[index,]
    S0[index]<-vapply(list, function(x) sum(exp(z_temp[x:size_temp,]%*%theta%*%(B_spline_temp[x,]))),FUN.VALUE=numeric(1))
  }
  
  temp=delta/S0
  
  Lambda=rep(0,n)
  F_key=0
  while (F_key<number_facility){
    F_key=F_key+1
    index=which(facility==F_key)
    Lambda[index]=cumsum(temp[index])
  }
  
  list(Lambda=Lambda) 
} 
#######################################################################333




###############extend data for time-varying ######################
data_extend<- function(delta2=delta, time2=time, z2=z, bs7_2=bs7) {
  
  n=length(time2)
  delta_new = numeric(n*(n+1)/2)
  time_start = numeric(n*(n+1)/2)
  time_stop = numeric(n*(n+1)/2)
  z_new = matrix(0, n*(n+1)/2,p)
  bs_new = matrix(0, n*(n+1)/2,knot)
  index = numeric(n*(n+1)/2)
  
  key=0
  i=0
  repeat {
    i=i+1
    
    j=0
    repeat{
      j=j+1
      
      delta_new[key+j] = delta2[i]*(i==j)
      if (j==1) {
        time_start[key+j]=0
      }
      
      if (j>1) {
        time_start[key+j]=time2[j-1]
      }  
      
      time_stop[key+j]=time2[j]
      z_new[key+j,]=z2[i,]
      bs_new[key+j,]=bs7_2[j,] 
      index[key+j]=j
      if(j==i) break
    }
    
    key=key+j 
    if(i==n) break
  }
  list(delta_new=delta_new, time_start=time_start, time_stop=time_stop, z_new=z_new, bs_new=bs_new, index=index)
}
##############################################################################################


###############extend data for time-varying ######################
data_extend_stratify<- function(delta2=delta, time2=time, z2=z, bs7_2=bs7,facility=facility) {
  
  n=length(time2)
  delta_new = numeric(n*(n+1)/2)
  time_start = numeric(n*(n+1)/2)
  time_stop = numeric(n*(n+1)/2)
  facility_new = numeric(n*(n+1)/2)
  z_new = matrix(0, n*(n+1)/2,p)
  bs_new = matrix(0, n*(n+1)/2,knot)
  index = numeric(n*(n+1)/2)
  
  key=0
  i=0
  repeat {
    i=i+1
    
    j=0
    repeat{
      j=j+1
      
      delta_new[key+j] = delta2[i]*(i==j)
      if (j==1) {
        time_start[key+j]=0
      }
      
      if (j>1) {
        time_start[key+j]=time2[j-1]
      }  
      
      time_stop[key+j]=time2[j]
      facility_new[key+j] = facility[j]
      z_new[key+j,]=z2[i,]
      bs_new[key+j,]=bs7_2[j,] 
      index[key+j]=j
      if(j==i) break
    }
    
    key=key+j 
    if(i==n) break
  }
  list(delta_new=delta_new, time_start=time_start, time_stop=time_stop, z_new=z_new, bs_new=bs_new, index=index, facility_new=facility_new)
}
##############################################################################################

